package bowling;

import java.util.Scanner;

public class Frame {
	private int num;
	private int nbPinsFirstThrow;
	private int nbPinsSecondThrow;
	private Frame nextFrame;

	public Frame(int num, Frame nextFrame) {
		this.num = num;
		this.nextFrame = nextFrame;
	}

	//TODO
	public int getNbPins() {
		return this.nbPinsFirstThrow + this.nbPinsSecondThrow;
	}

	//TODO
	public boolean isStrike() {
		return num <= 10 && nbPinsFirstThrow == 10;
	}

	//TODO
	public boolean isSpare() {
		return num <= 10 && nbPinsFirstThrow != 10
				&& getNbPins() == 10;
	}

	/**
	 * Precondition : called only if not in a bonus frame (next frame and next
	 * next frame are not null)
	 * 
	 * @return
	 */
	private int getNbPinsNextThrow() {
		return nextFrame.nbPinsFirstThrow;
	}

	/**
	 * Precondition : called only if not in a bonus frame (next frame and next
	 * next frame are not null)
	 * 
	 * @return
	 */
	private int getNbPinsNextNextThrow() {
		if (nextFrame.nbPinsFirstThrow == 10) {
			return nextFrame.nextFrame.nbPinsFirstThrow;
		}
		return nextFrame.nbPinsSecondThrow;
	}

	//TODO
	public int score() {
		if (this.isStrike()) {
			return 10 + getNbPinsNextThrow() + getNbPinsNextNextThrow();
		}
		if (this.isSpare()) {
			return 10 + getNbPinsNextThrow();
		}
		return getNbPins();
	}

	@Override
	public String toString() {
		return "Frame " + num + ": " + (isStrike() ? "XXX"
				: isSpare() ? "/" : nbPinsFirstThrow + " " + nbPinsSecondThrow);
	}

	public void playFrame(Scanner sc) {
		System.out.println("Frame numero " + this.num + ", premier lancer : ");
		this.nbPinsFirstThrow = sc.nextInt();
		if (nbPinsFirstThrow < 0 || nbPinsFirstThrow > 10) {
			throw new RuntimeException("Nombre de quilles invalide");
		}

		if (this.nbPinsFirstThrow == 10) {
			return;
		}

		System.out.println("Frame numero " + this.num + ", deuxime lancer : ");
		this.nbPinsSecondThrow = sc.nextInt();
		if (nbPinsSecondThrow < 0
				|| nbPinsSecondThrow > 10 - nbPinsFirstThrow) {
			throw new RuntimeException("Nombre de quilles invalide");
		}
	}
}
